#include <iostream>
#include <set>
#include <math.h>
#include <queue>

using namespace std;

#define ll int


int main()
{
    int H, W;
    while(cin >> H)
    {

        cin >> W;
        char m[H][W];
        ll vx = 0, vy = 0;
        for(int i = 0; i < H; i++){
            for(int j = 0; j < W; j++){
                cin >> m[i][j];
                if(m[i][j] == 'X') { vy = i; vx = j; }
            }
        }

        ll last = W;
        for(int i = 0; i < H; i++){
            for(int j = 0; j < W; j++){
                if(j == last) break;
                if(m[i][j] != '.') {last = j; break;}
                else m[i][j] = '*';
            }
        }

        last = 0;
        for(int i = 0; i < H; i++){
            for(int j = W-1; j >= 0; j--){
                if(j == last) break;
                if(m[i][j] != '.') {last = j; break;}
                else m[i][j] = '*';
            }
        }

        last = W;
        for(int i = H-1; i >= 0; i--){
            for(int j = 0; j < W; j++){
                if(j == last) break;
                if(m[i][j] != '.') {last = j; break;}
                else m[i][j] = '*';
            }
        }

        last = 0;
        for(int i = H-1; i >= 0; i--){
            for(int j = W-1; j >= 0; j--){
                if(j == last) break;
                if(m[i][j] != '.') {last = j; break;}
                else m[i][j] = '*';
            }
        }

        queue<pair<pair<ll, ll>, ll> > q;
        set<pair<ll, ll> > s;
        ll res = 0;
        q.push(make_pair(make_pair(vx, vy), 0));
        s.insert(make_pair(vx, vy));
        while(!q.empty())
        {
            auto pp = q.front();
            q.pop();
            ll x = pp.first.first, y = pp.first.second, l = pp.second;
            if(m[y][x] == '*') { res = l; break; }
            if(m[y][x] == 'O') { continue; }
            if(y > 0 && !s.count(make_pair(y-1, x))) {q.push(make_pair(make_pair(y-1, x), l+1)); s.insert(make_pair(y-1, x)); }
            if(x > 0 && !s.count(make_pair(y, x-1))) {q.push(make_pair(make_pair(y, x-1), l+1)); s.insert(make_pair(y, x-1)); }
            if(y < H-1 && !s.count(make_pair(y+1, x))) {q.push(make_pair(make_pair(y+1, x), l+1)); s.insert(make_pair(y+1, x)); }
            if(x < W-1 && !s.count(make_pair(y, x+1))) {q.push(make_pair(make_pair(y, x+1), l+1)); s.insert(make_pair(y, x+1)); }
        }

        ll miny = 0, minx = 0, maxx = W, maxy = H;
        for(int i = 0; i < H; i++){
            for(int j = 0; j < W; j++){
                if(m[i][j] != '*') goto a1;
            }
            miny++;
        }
        a1:

        for(int i = H-1; i >= 0; i--){
            for(int j = 0; j < W; j++){
                if(m[i][j] != '*') goto a2;
            }
            maxy--;
        }
        a2:

        for(int j = 0; j < W; j++){
            for(int i = 0; i < H; i++){
                if(m[i][j] != '*') goto a3;
            }
            minx++;
        }
        a3:
        for(int j = W-1; j >= 0; j--){
            for(int i = 0; i < H; i++){
                if(m[i][j] != '*') goto a4;
            }
            maxx--;
        }
        a4:
        ll o = 2*((maxx-minx)+(maxy-miny)) + 2*res;

        cout << o << '\n';


        for(int i = 0; i < H; i++){
            for(int j = 0; j < W; j++){
                cout << m[i][j];
            }
            cout << '\n';
        }



    }

    return 0;
}
